/******************************************************************************
*
* project name:    Scorch
* file name:       Main##.c
* initial date:    12.4.2004
* author:          mhubi@freesurf.ch
* description:     main c-source file
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004-2005  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h13.h"

#if defined(TI_BIG)
	#warning "Building the ti92+/v200 version"
#elif defined(TI_SMALL)
	#warning "Building the ti89 version"
#endif

#if defined(VTI)
	#warning "Compiling for VTI"
#endif

#if defined(TESTING)
	#warning "Test version"
#endif

//global variables
INT_HANDLER save_int_1;
INT_HANDLER save_int_5;
PLAYERINF *player;
char *homescreen;
GAME *game;
int *earth;
unsigned char *title;
int curfunc;
void *bulk;
CLOUD *cloud;
volatile int counter = 0;


DEFINE_INT_HANDLER (CLOUDINT) {
	
	counter++;
	
	if (counter == 15) {
		counter = 0;
		DrawClouds();
	}
	
	//ExecuteHandler(oldint5);
	  
}


// Main Function
void _main(void)
{
	
	save_int_1 = GetIntVec(AUTO_INT_1);
	save_int_5 = GetIntVec(AUTO_INT_5);
	
	#if defined(VTI)
	
	if (IsVTI() == TRUE) {
		ST_helpMsg("Warning, certain parts are faster on VTI");
		ngetchx();
		ST_eraseHelp();
	}
	
	#endif
	
	MemoryAllocation();
	
	game->status = NEWGAME;
	
	LCD_save(homescreen);
	
	//Intro();
	if (OptionsRequest() == TRUE) {
		BoolsoftIntro(TRUE);
	}
	
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	
	if(!GrayOn()) {
		LeadOut(MEMORY);
	}
	
	while (game->status == NEWGAME) {
		
		randomize();
		
		Welcome();
		
		if (game->status != GAMELOADED && game->status != QUICKSTART) {
		
			PlayerSettings();
			
			GameSettings();
		
		}
		
		if (game->set[START] != 0 && game->status != GAMELOADED) {
			SetStartValues();
		}
		
		GameLoop();
		
		//Waitkey();
		
		while (game->status != NEWGAME) {
			MainMenu();
		}
		
	}
	
}


/*void Intro(void) {
	
	unsigned int loop1, line, square, loop2, place, x;
	
	FastFillRect(LCD_MEM, 0, 0, CALC(159,239), CALC(99,127), A_XOR);
	
	FontSetSys(F_8x10);
	DrawStr(CALC(48,88), CALC(40,54), "boolsoft", A_REVERSE);
	FontSetSys(F_6x8);
	DrawStr(CALC(56,96), CALC(60,74), "presents", A_REVERSE);
	
	for (loop1 = 0; loop1 < 30; loop1++) {
		#if defined(VTI)
		VTIPoking();
		#else
		idle();
		#endif
	}
	
	for (loop1 = 0; loop1 < 4; loop1++) {
		place = loop1;
		for (line = 0; line < CALC(13,16); line++) {
			if (place > 3) {
				place = 0;
			}
			for (square = 0; square < CALC(20,30); square+=4) {
				x = square*8 + place * 8;
				if (x < 240) {
					ClipSprite8_AND_R(x, line*8 , 8, mask, LCD_MEM);
				}
			}
			place++;
		}
		for (loop2 = 0; loop2 < 7 && loop1 != 3; loop2++) {
			#if defined(VTI)
			VTIPoking();
			#else
			idle();
			#endif
		};
	}
	
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	
	if(!GrayOn()) {
		LeadOut(MEMORY);
	}
	
}*/

void Welcome(void) {
	
	//unsigned char title[CALC(770,1600)];
	
	curfunc = WELCOME;
	
	GrayClearScreen();
	
	//titleimage
	
	DecompRLEVert(title1_rle, title, CALC(770,1600), CALC(14,20), CALC(55,80));
	
	//#if defined(TI_BIG)
	SpriteX8_OR(CALC(24,30),0,CALC(55,80),title,CALC(14,20),DPLANE);
	
	DecompRLEVert(title2_rle, title, CALC(770,1600), CALC(14,20), CALC(55,80));
	
	SpriteX8_OR(CALC(24,30),0,CALC(55,80),title,CALC(14,20),LPLANE);
	//#endif
	
	//choose rounds and players
	P_R_choose();
	
}


void GameLoop(void) {
	
	//int key = 0;
	
	//randomize();
	
	Wait();
	
	if (game->status == NEWGAME || game->status == QUICKSTART) {
		game->status = NEWROUND;
	}
	
	//main-game-loop	
	while (game->rounds_now <= game->rounds && game->status >= NORMAL) {
		
		curfunc = GAMELOOP;
		
		GrayClearScreen();
		
		if (game->status != GAMELOADED) {
			
			InitRound();
			
			Landscape(game->set[LAND]);
			
			for (game->pl_active = 0; game->pl_active < game->pl_num; game->pl_active++) {
				Tankset(game->pl_active);
			}
			
			/*for (game->pl_active = 0; game->pl_active < game->pl_num; game->pl_active++) {
				if (player[num].strength == AISTRENGTH) {
					
					player[num].strength = 1 + random(AISTRENGTH-1);
									
				}
			}*/
			
			for (game->pl_active = 0; game->pl_active < game->pl_num; game->pl_active++) {
				
				if (player[game->pl_active].type == 2) {
					
					if (player[game->pl_active].strength == AISTRENGTH) {
						player[game->pl_active].strength = 1 + random(AISTRENGTH-1);
					}
					
					ChooseEnnemi(game->pl_active, FALSE);
					//player[game->pl_active].angle_img = player[game->pl_active].angle;
					//printf("%d; ", player[game->pl_active].strength);
				}
				
			}
			
			InitClouds();
			
			game->pl_active = 0;
		
		}
		
		DrawScreen();
		
		DrawClouds();
		
		if (game->status != GAMELOADED && game->set[SPECIAL] == 1 && random(40) < (short)(20 + (game->pl_num-2)*5)) {
			SpecialEvent();
		}
		
		game->status = NORMAL;
		
		SetIntVec(AUTO_INT_5, CLOUDINT);
		
		PlayRound();
		
		// show the statistics
		Statistics();
		
		Waitkey();
		
		if (game->rounds_now == game->rounds) {
			game->status = ENDGAME;
			return;
		}
		
		
		// if there's a round to play show the shop for each human-player
		else if (game->rounds_now != game->rounds) {
			
			/*while ((key = KeyPressed()) != K_ENTER) {
				pokeIO(0x600005, 0b10111);
			}*/
			
			//curfunc = SHOP;
			
			for (game->pl_check = 0; game->pl_check < game->pl_num && game->status == NORMAL; game->pl_check++) {
				if (player[game->pl_check].type == 1 && player[game->pl_check].credits > 0) {
					
					// show the shop
					Shop(game->pl_check);
					
				}
				
				//#if defined (TESTING)
				else if (player[game->pl_check].type == 2) {
					AiShop();
				}
				//#endif
				
			}
			if (game->status == NORMAL) {
				game->status = NEWROUND;
				game->rounds_now++;
			}
		
		}
		
		
	} // main-game-loop-end
	
	
} // function-end


void PlayRound(void) {
	
	int key = 0;
	TARGET target;
	
	curfunc = PLAYROUND;
	
	// round-loop, each players round, exits only if status != NORMAL		
	//for (game->pl_active = 0; game->pl_active <= game->pl_num && game->status == NORMAL; game->pl_active++) {
	for (; game->pl_active <= game->pl_num && game->status == NORMAL; game->pl_active++) {
		
		// if each player has shot player no 1 can shoot
		if (game->pl_active == game->pl_num) {
			game->pl_active = 0;
			//Clouds();
		}
		
		if (cloud->number >= 5 && random(20 - cloud->number) == 0 && game->set[WEATHER] != 0) {
			SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
			MainFlash();
			CheckLife(FALSE);
			SetIntVec(AUTO_INT_5, CLOUDINT);
		}
		else if (game->set[WEATHER] != 0 && random(20) == 0) {
			Earthquake(random(CALC(159,239)), random(CALC(159,239)), 5 + random(10), FALSE);
			CheckLife(FALSE);
		}
		
		//DrawScreen();
		
		key = KeyPressed();
		
		/*if (_keytest(RR_APPS)) {
			game->status = QUIT;
			MainMenu();
		}
		else if (_keytest(RR_F2)) {
			LeadOut(FASTQUIT);
		}*/
		
		// he can only shoot if he's still alive
		if (player[game->pl_active].life != 0) {
			
			//Dispinf(game->pl_active);
			//GrayClearScreen();
			//DrawScreen();
			
			// case 1: human-player
			if (player[game->pl_active].type == 1) {
				
				key = 0;
				
				Dispinf(game->pl_active);
				
				//Aidata();
				
				// !! possible to change the status --> everything: status == NORMAL
				while (key != K_ENTER && game->status == NORMAL) {
					
					while (!(key = KeyPressed()) && game->status == NORMAL) {
						pokeIO(0x600005, 0b10111);
					}
					
					//choose angle
					if (key == K_LEFT || key == K_LEFT + K_2ND || key == K_RIGHT || key == K_RIGHT + K_2ND) {
						Angle(game->pl_active, key);
						Delay(AUTO_REPEAT);
					}
					
					else if (key == K_UP || key == K_UP + K_2ND || key == K_DOWN || key == K_DOWN + K_2ND) {
						Power(&player[game->pl_active].power, key);
						Delay(AUTO_REPEAT);
					}
					
					else if (key == K_Q) {
						SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
						Inventory(game->pl_active);
						Dispinf(game->pl_active);
						SetIntVec(AUTO_INT_5, CLOUDINT);
					}
					
				}
				
				if (key == K_ENTER && game->status == NORMAL) {
					
					MainShot(game->pl_active, &target);
					
					/*if (player[game->pl_active].bomb[0] < LASERLITTLE) {
						ShotEngine(game->pl_active, &target);
					}
					Explosion(target->x, target->y, game->pl_active);*/
					
				}
				
				
			}
			
			// case 2: computer-player
			if (player[game->pl_active].type == 2 && game->status == NORMAL) {
				
				//#if defined(TESTING)
				
				AiMain(&target, PRE);
				
				Dispinf(game->pl_active);
				
				//#endif
				
				//Inventory(game->pl_active);
				
				MainShot(game->pl_active, &target);
				
				/*if (player[game->pl_active].bomb[0] < LASERLITTLE) {
					ShotEngine(game->pl_active, &target);
				}
				Explosion(target->x, target->y, game->pl_active);*/
				
				//oldold
				
			}
			
			// after each shot control if a player died with the last shot
			// --> credits->->->
			CheckLife(TRUE);
			/*for (game->pl_check = 0; game->pl_check < game->pl_num && game->status == NORMAL; game->pl_check++) {
				if (player[game->pl_check].life != 0) {
					//HealthControl(game->pl_check);
					//TankFall(game->pl_check);
					
					if (player[game->pl_check].health <= 0 && player[game->pl_check].life != 0) {
						
						player[game->pl_check].bomb[0] = 0;
						Explosion(player[game->pl_check].x, player[game->pl_check].y - 4, game->pl_check, TRUE);
						
						game->pl_alive--;
						player[game->pl_check].life = 0;
						
						if (player[game->pl_active].life != 0) {
							player[game->pl_active].cr_total += 1000;
							
							if(player[game->pl_active].credits <= 59000) {
								player[game->pl_active].credits += 1000;
							}
							
						}
					
					}
				
				}
				
			}*/
			
			if (game->status == NEWROUND) {
				game->status = NORMAL;
			}
			
			// get out of the round-loop if less than two players are alive
			// --> statistics
			if (game->pl_alive < 2) { 
				
				return;
					
			} // end of "end-of-round"-loop
			
			// ai if computer-player is active
			if (player[game->pl_active].type == 2 && game->status == NORMAL) {
				//#if defined(TESTING)
				AiMain(&target, AFTER);
				/*#else
				Ai();
				#endif*/
			}
			
		} // end of the shot-n-control-procedure
		
		if (game->set[WIND] > 3) {
			ChangingWind();
		}
		
	} // round-loop-end
	
	
}


void Extro(void) {
	
	
	// shows the end-screen with the quotation
	GrayClearScreen();
	FontSetSys(CALC(F_6x8,F_8x10));
	GrayDrawStr(CALC(20,30),CALC(25,35),(char*)"There's many a boy",A_NORMAL);
	GrayDrawStr(CALC(20,30),CALC(34,46),(char*)"here today who looks",A_NORMAL);
	GrayDrawStr(CALC(20,30),CALC(43,57),(char*)"on war as all glory,",A_NORMAL);
	GrayDrawStr(CALC(20,30),CALC(52,68),(char*)"but, boys, it is all",A_NORMAL);
	GrayDrawStr(CALC(20,30),CALC(61,79),(char*)"hell. - Gen. Sherman",A_NORMAL);
	
	GrayDrawStrExt(0,CALC(80,100),(char*)"boolsoft '05 -- mhubi@freesurf.ch",A_NORMAL | A_CENTERED, CALC(F_4x6,F_6x8));
	GrayDrawStrExt(0,CALC(88,110),(char*)"http://boolsoft.mobifiles.de",A_NORMAL | A_CENTERED, CALC(F_4x6,F_6x8));
	
	Waitkey();
	
}


void Delay(unsigned int delay) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 <= delay; loop1++) {
		#if defined(VTI)
		VTIPoking();
		#else
		pokeIO(0x600005, 0b10111);
		#endif
	}
	
}


void LeadOut(int mode) {
	
	if (mode == MEMORY) {
		ST_helpMsg("Free up more RAM");
		exit(0);
	}
	
	if (mode != FASTQUIT) {
		Extro();
	}
	
	Wait();
	
	GrayOff();
	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5, save_int_5);
	
	LCD_restore(homescreen);
	
	
	if (mode != FASTQUIT) {
		ST_helpMsg(CALC("      ~~ Scorch "COMMENT_VERSION_STRING"   by boolsoft ~~",
										"                               ~~ Scorch "COMMENT_VERSION_STRING"   by boolsoft ~~"));
	}
	
	free(bulk);
	
	exit(0);
	
}

void MainMenu(void) {
	
	int choice = 1;
	LCD_BUFFER plane1, plane2;
	int curfunc_old, font_old;
	
	Wait();
	
	font_old = FontGetSys();
	
	FastCopyScreen_R(LPLANE, plane1);
	FastCopyScreen_R(DPLANE, plane2);
	
	curfunc_old = curfunc;
	curfunc = MAINMENU;
	
	Rectangle();
	
	GrayDrawStrExt(0, CALC(15,29), (char*)"NEXT ACTION?", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	
	GrayDrawStrExt2B(0, CALC(29,43), (char*)"Return   ", A_NORMAL | A_CENTERED, F_6x8, DPLANE, DPLANE);
	
	GrayDrawStrExt2B(0, CALC(37,51), (char*)"Quit Game", A_NORMAL | A_CENTERED, F_6x8, DPLANE, DPLANE);
	
	GrayDrawStrExt2B(0, CALC(45,59), (char*)"Mass Kill", A_NORMAL | A_CENTERED, F_6x8, DPLANE, DPLANE);
	
	GrayDrawStrExt2B(0, CALC(53,67), (char*)"New Game ", A_NORMAL | A_CENTERED, F_6x8, DPLANE, DPLANE);
	
	GrayDrawStrExt2B(0, CALC(61,75), (char*)"Save Game", A_NORMAL | A_CENTERED, F_6x8, DPLANE, DPLANE);
	
	GrayDrawStrExt2B(0, CALC(69,83), (char*)"Load Game", A_NORMAL | A_CENTERED, F_6x8, DPLANE, DPLANE);
	
	if (game->status == ENDGAME) {
		DeleteMenuEntry(1);
	}
	if (curfunc_old != PLAYROUND) {
		DeleteMenuEntry(3);
	}
	if (game->status != ENDGAME) {
		DeleteMenuEntry(4);
	}
	if (curfunc_old != PLAYROUND) {
		DeleteMenuEntry(5);
	}
	if (curfunc_old != WELCOME && curfunc_old != PLAYROUND) {
		DeleteMenuEntry(6);
	}
	
	DialogStatusLine(0);
	
	//Memory();
	
	/*while ((key < K_1 || key > K_6) && key != K_ESC) {
		
		key = KeyPressed();
		
		pokeIO(0x600005, 0b10111);
		
	}*/
	
	do {
		
		choice = MakeChoice(CALC(53,91), CALC(29,43), 8, 6, F_6x8, choice);
		
		if ((choice == 1 || choice == -10) && game->status != ENDGAME) {
			if (game->status != PLAYROUND) {
				FastCopyScreen_R(plane1, LPLANE);
				FastCopyScreen_R(plane2, DPLANE);	
			}
			break;
		}
		
		if (choice == 2 || (choice == -10 && game->status == ENDGAME)) {
			LeadOut(QUIT);
		}
		
		if (choice == 3 && curfunc_old == PLAYROUND) {
			game->status = NEWROUND;
			break;
		}
		
		if (choice == 4 && game->status == ENDGAME) {
			game->status = NEWGAME;
			curfunc = curfunc_old;
			return;
		}
		
		if (choice == 5 && curfunc_old == PLAYROUND) {
			SaveGame();
			break;
		}
		
		if (choice == 6 && (curfunc_old == PLAYROUND || curfunc_old == WELCOME)) {
			
			LoadGame();
			
			if (curfunc_old == WELCOME) {
				game->status = GAMELOADED;
				curfunc = curfunc_old;
			}
			
			break;
			
		}
		
	} while (choice > 0); //dummy...
	
	
	/*if (choice == K_6 && curfunc_old != WELCOME) {
		GrayClearScreen();
		game->status = NORMAL;
		DrawScreen();
	}
	else if (game->status != ENDGAME) {
		game->status = NORMAL;
		GrayClearScreen();
		
		//FastCopyScreen_R(plane1, LPLANE);
		//FastCopyScreen_R(plane2, DPLANE);
	}*/
	
	curfunc = curfunc_old;
	FontSetSys(font_old);
	
	Wait();
	
	if (curfunc_old == PLAYROUND) {

		/*FastCopyScreen_R(plane1, LPLANE);
		FastCopyScreen_R(plane2, DPLANE);*/
		
		GrayClearScreen();
		DrawScreen();
		DrawClouds();
		SetIntVec(AUTO_INT_5, CLOUDINT);
		
		if (game->status == NEWROUND) {
			MassKill();
		}
		
	}
	
	/*if (key == K_3 && curfunc_old == PLAYROUND) {
		game->status = NEWROUND;
		MassKill();
	}*/
	
}

void MemoryAllocation(void) {
	
	#define BULKSIZE sizeof(PLAYERINF)*5 + LCD_SIZE + sizeof(GAME) + sizeof(int)*240 + sizeof(unsigned char)*1600 + sizeof(CLOUD)
	
	bulk = NULL;
	
	if ((bulk = malloc(BULKSIZE)) == NULL) {
		LeadOut(MEMORY);
	}
	
	player = 			(PLAYERINF*)		((char*)bulk);
	homescreen = 	(char*)					((char*)player + sizeof(PLAYERINF)*5);
	game = 				(GAME*)					((char*)homescreen + LCD_SIZE);
	earth =				(int*)					((char*)game + sizeof(GAME));
	title =				(unsigned char*)((char*)earth + sizeof(int)*240);
	cloud =				(CLOUD*)				((char*)title + sizeof(unsigned char)*1600);
	
	/*if ((player = malloc(sizeof(PLAYERINF)*5)) == NULL) {
		LeadOut(MEMORY);
	}
	if ((homescreen = malloc(LCD_SIZE)) == NULL) {
		LeadOut(MEMORY);
	}
	if ((game = malloc(sizeof(GAME))) == NULL) {
		LeadOut(MEMORY);
	}
	if ((earth = malloc(sizeof(int)*240)) == NULL) {
		LeadOut(MEMORY);
	}
	if ((title = malloc(sizeof(unsigned char)*1600)) == NULL) {
		LeadOut(MEMORY);
	}*/
	
}

//prototype from the tigcc-tools-suite/ttmem
/*void Memory(void) {
	
	char string[100];
	
	FontSetSys(F_4x6);
	HeapCompress();
  sprintf(string, "avail=%lu bytes (maxblock=%lu)", HeapAvail(), HeapMax());
  GrayDrawStr(32, 70, string, A_NORMAL);
	
}*/


#if defined(VTI)

// VTI detection routine (thanx go to Julien Muchembled); taken from travis fischers icehockey68k
short IsVTI(void);
asm("
IsVTI:
    trap   #12         /* enter supervisor mode. returns old (%sr) in %d0.w   */
    move.w #0x3000,%sr /* set a non-existing flag in %sr (but keep s-flag !!) */
    swap   %d0         /* save %d0.w content in upper part of %d0             */
    move.w %sr,%d0     /* get %sr content and check for non-existing flag     */
    btst   #12,%d0     /* this non-existing flag can only be set on the VTI   */
    bne    __VTI           
    swap   %d0         /* restore old %sr content and return 0                */
    move.w %d0,%sr
    moveq  #0,%d0
    rts
__VTI:
    swap   %d0         /* restore old %sr content and return 1                */
    move.w %d0,%sr
    moveq  #1,%d0
    rts
");

void VTIPoking(void) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < 1430; loop1++);
	
}

#endif

//#if defined(TESTING)

void Debugging(unsigned int num) {
	
	num++;
	
	Waitkey();
	//EXT_XORPIX(DPLANE, player[1].x, earth[player[1].x]);
  Waitkey();
	//EXT_XORPIX(DPLANE, player[1].x, earth[player[1].x]);
	Waitkey();
	
}

//#endif

//ti89 version: completely done