/******************************************************************************
*
* project name:    Scorch
* file name:       data##.h
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     all kind of data
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004-2005  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

//various strings
const char *statusmsg[] = {"ARROWS AND [ENTER] = MAKE YOUR DECISION", "TYPE IN YOUR NAME : [ENTER] = OK", 
													 "\x15/\x16=CHANGE : ENTER=GO ON : F1=LOAD OPT.", 
													 "[ENTER] = CONTINUE"}; 
const char *compnames[] = {"Ronald","Angie","Galileo","Tiffany","Amadeus"};
//const char *landscape[] = {"very flat","flat","hilly","quite hilly","mountainous","very mountainous","random"};
const char *aistrenght[] = {"stupid","easy", "normal", "calcophil", "avenger", "tricky", "random"};
/*const char *wind[] = {"none", "constant low", "constant middle", "constant high", "changing low", "changing middle", "changing high", "random"};
const char *startvalues[] = {"off", "little", "middle", "big", "random"};
const char *onoff[] = {"off", "on", "random"};
const char *walls[] = {"permeable", "reflecting", "swallowing", "random"};
const char *weather[] = {"good", "good or bad", "bad", "random"};*/
const char *options[] = {"very flat","flat","hilly","quite hilly","mountainous","very mountainous","random",
												 "none", "constant low", "constant middle", "constant high", "changing low", "changing middle", "changing high", "random",
												 "off", "little", "middle", "big", "random",
												 "off", "on", "random",
												 "permeable", "reflecting", "swallowing", "random",
												 "good", "good or bad", "bad", "random"										 
												 };
//const char *options_title[] = {"landscape:", "wind:", "startvalues:", "special events:", "walls:", "weather:"};
const short st_point[] = {0, 7, 15, 20, 23, 27};
const short opt_limit[] = {6, 7, 4, 2, 3, 3};
const char *bombname[] = {"","Baby Missile","Missile","Baby Nuke","Nuke","Napalm","Hot Napalm",
													"Laser little","Laser big","Funky Bomb","Death's Head","MIRV","Extended MIRV", 
													"Baby Digger","Monster Digger","Battery","Parachute","Shield little","Shield big"
													};
const char *bombcost[] = {"         free","  5 for 1000cr","  2 for 2000cr.","  1 for 4000cr.","  2 for 2500cr.","  1 for 5000cr.",  
													"  2 for 3000cr.","  1 for 5000cr.","  2 for 4500cr.","  1 for 6000cr.","  2 for 7500cr.","  1 for 8000cr.",
													"  3 for 2500cr.","  2 for 6500cr.","  5 for 1000cr.","  2 for 5000cr.","  2 for 4000cr.","  1 for 5000cr."
													};
const char *gamefile = "scorchgs";
const char *optfile = "scorchos";

unsigned char fire[7][12] = {{0x14,0x80,0x20,0x04,0x4E,0x0A,0x12,0x57,0xFF,0xBD,0xDD,0x5A},
														 {0x00,0x02,0x00,0x00,0x00,0x84,0x0C,0x0C,0x1E,0x7E,0x3E,0x3E},
														 {0x08,0xC0,0xE1,0x50,0x50,0x4C,0x82,0x93,0x91,0x59,0x5A,0x3C},
														 {0x01,0x00,0x28,0x20,0x20,0x30,0x7C,0x7C,0x7E,0x3E,0x3C,0x1C},
														 {0x04,0x00,0x91,0x18,0x28,0x28,0x46,0x81,0x89,0x99,0x5A,0x3C},
														 {0x00,0x00,0x04,0x00,0x10,0x90,0x38,0x7E,0x7E,0x7E,0x3C,0x1C},
														 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}};

unsigned char parachute[] = {0x38,0x44,0xAA,0x10};
unsigned char shield[] = {0xFE,0xF2,0xF2,0xFE,0x9E,0x5C,0x38};

//unsigned char projectile[] = {0x01, 0x00, 0x00, 0x00};

int merchpage[] = {6, 6, 6};

unsigned char mask[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
//unsigned short tank_mask_top[] = {0xC01F,0x800F,0x800F,0x0007,0x0007};
unsigned short tank_mask[] = {0xC01F,0xC01F,0xC01F,0xC01F,0xC01F};
//unsigned short tank_mask[] = {0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F};

unsigned char tube[21][4] = {
													 	{0x00, 0x00, 0x00, 0x0F},
														{0x00, 0x00, 0x03, 0x0C},
														{0x00, 0x00, 0x07, 0x08},
														{0x00, 0x01, 0x06, 0x08},
														{0x00, 0x03, 0x04, 0x08},
														{0x01, 0x02, 0x04, 0x08},
														{0x02, 0x04, 0x04, 0x08},
														{0x04, 0x04, 0x08, 0x08},
														{0x04, 0x08, 0x08, 0x08},
														{0x08, 0x08, 0x08, 0x08},
														{0x08, 0x08, 0x08, 0x08},
														{0x08, 0x08, 0x08, 0x08},
														{0x10, 0x08, 0x08, 0x08},
														{0x10, 0x10, 0x08, 0x08},
														{0x20, 0x10, 0x10, 0x08},
														{0x40, 0x20, 0x10, 0x08},
														{0x00, 0x60, 0x10, 0x08},
														{0x00, 0x40, 0x30, 0x08},
														{0x00, 0x00, 0x70, 0x08},
														{0x00, 0x00, 0x60, 0x18},
														{0x00, 0x00, 0x00, 0x78}
													  };

unsigned int tank_pixel_mass[] = {18, 24, 25, 21, 20, 17, 19};

unsigned int bomb_skill[MERCH][3] = {
																				{0, 0, 1},
																				{5, 1000, 4},
																				{2, 2000, 8},
																				{1, 4000, 16},
																				{2, 2500, 50},
																				{1, 5000, 100},
																				
																				{2, 3000, 50},
																				{1, 6000, 100},
																				{2, 4500, 8},
																				{1, 6000, 16},
																				{2, 7500, 8},
																				{1, 8000, 16},
																				
																				{3, 2500, 25},
																				{2, 6500, 50},
																				{5, 1000, 0},
																				{2, 5000, 0},
																				{2, 4000, 10},
																				{1, 5000, 30}
																				
																				};

unsigned short tanks[TANKS][5] = {{0x38,0x10,0x7C,0xAA,0x7C}, 
																	{0x38,0x7C,0xFE,0xAA,0x7C},
																	{0x7C,0x38,0xFE,0xFE,0x54},
																	{0x7C,0x38,0x7C,0xBA,0x54},
																	{0x38,0x44,0x7C,0xD6,0x7C},
																	{0x10,0x28,0x44,0xFE,0x7C},
																	{0x7C,0x38,0x6C,0x6C,0x92}};


unsigned short cloud_sprite[5][8] = {{0x0000,0x073E,0x1FFF,0x7FFF,0xFFFE,0x7FFE,0x1DA7,0x0000},
																 		 {0x070C,0x4F9E,0xFFDF,0xFFFE,0x7FFF,0x3FFF,0xFBFE,0xD0A4},
																		 {0x1600,0x3F10,0x7FBA,0xFFFF,0xFFFF,0x7FFF,0x1F3E,0x0E18},
																	 	 {0x0300,0x4798,0xFFFA,0xFFFF,0x7FFF,0x3FFF,0x797E,0x3038},
																	 	 {0x0020,0x0078,0x05FA,0x1FFF,0x7FFE,0xFBBE,0x7088,0x0000}};

unsigned char font_mask[] = {0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA};

unsigned short int smiley[2][16] = {{0x07E0,0x1818,0x2004,0x4002,0x4C32,0x8C31,0x8001,0x8001,0x8001,0x9009,0x9009,0x4812,0x47E2,0x2004,0x1818,0x07E0},
																		{0x07E0,0x1818,0x2004,0x4002,0x4C32,0x8C31,0x8001,0x8001,0x87E1,0x8811,0x9009,0x500A,0x4002,0x2004,0x1818,0x07E0}};

const char *special_events[] = {"wins the 'Nobel Peace Prize'",
																"inherits from his grandmother",
																"finds in his trouser pocket",
																"celebrates his birthday today",
																"is caught in a rain of money",
																"gets from a collection of school kids",
																"is a Sunday-child",
																"is supported by obscure people",
																"has got many friends",
																"made a good joke",
																"is the only one who knows the cheats",
																"is beloved by the calc",
																"destroyed the garage of the neighbour",
																"has quarrel with 'Greenpeace'",
																"is hated by the calc",
																"is a kibitzer",
																"tries to cheat",
																"needs to much time for his decisions",
																"buys beer for his friends",
																"has driven too fast",
																"has no friends in the police",
																"overslept this morning",
																"hasn't got any luck",
																"supports charities"
																};
														